`crackrec` <-
function(x, threshold=NULL, alpha=1, beta=1, size=0) {
	ul <- function(mx)   {
		matrix(unlist(mx), nrow=2, byrow=FALSE)
	}
	
	if(!is.null(dim(x)[1]) && is.matrix(x) && is.numeric(alpha) && is.numeric(beta) && is.numeric(size))   {
		width<-dim(x)[1]
		if(is.logical(x))   {
			threshold<-1
			alpha<-0
			beta<-0
			erg<-.Call("crackrec", unlist((!x)*1), width, threshold, alpha, beta, as.integer(size), PACKAGE="crackrec")
		} else if(!is.logical(x) && alpha >= 0 && alpha <= 1 && beta >= 0 && beta <= 1 && size >= 0 && min(x)>=0)   {
			if(!is.numeric(threshold))   {
				threshold <- min(140, mean(x)*4/5)
				message("no threshold specified, using threshold = ", threshold) 
			}
			erg<-.Call("crackrec", as.numeric(unlist(x)), width, threshold, alpha, beta, as.integer(size), PACKAGE="crackrec")
			
		} else {
			warning("invalid parameters\n")
			cracks<-matrix(c(0, 0, rep(NA, 4)), nrow=6, dimnames=list(c("length", "size", "Begin_x", "Begin_y", "End_x", "End_y"),c()), byrow=FALSE)
			return(list(cracks=cracks, crackpaths=list(list(c(NA,NA))),crackclusters=list(list(c(NA,NA)))))
		}
	
		if(length(erg$cracks) > 1 & length(erg$crackpaths) > 1)   {
			myCracks<-matrix(unlist(erg$cracks), nrow=6, dimnames=list(c("length", "size", "Begin_x", "Begin_y", "End_x", "End_y"),c()), byrow=FALSE)
			myCrackpaths<-sapply(erg$crackpaths, ul)
			myCrackclusters<-sapply(erg$crackclusters, ul)
			return(list(cracks=myCracks,crackpaths=myCrackpaths, crackclusters=myCrackclusters))
#return(list(cracks=myCracks,crackpaths=erg$crackpaths, crackclusters=erg$crackclusters))
		}    else if(length(erg$cracks) > 0 & length(erg$crackpaths) > 0)  {
			myCracks<-matrix(unlist(erg$cracks), nrow=6, dimnames=list(c("length", "size", "Begin_x", "Begin_y", "End_x", "End_y"),c()), byrow=FALSE)
			myCrackpaths<-list(matrix(unlist(erg$crackpaths), nrow=2, byrow=FALSE))
			myCrackclusters<-list(matrix(unlist(erg$crackclusters), nrow=2, byrow=FALSE))
			return(list(cracks=myCracks,crackpaths=myCrackpaths, crackclusters=myCrackclusters))
		}   else   {
			warning("no cracks found\n")
			cracks<-matrix(c(0, 0, rep(NA, 4)), nrow=6, dimnames=list(c("length", "size", "Begin_x", "Begin_y", "End_x", "End_y"),c()), byrow=FALSE)
			return(list(cracks=cracks, crackpaths=list(list(c(NA,NA))),crackclusters=list(list(c(NA,NA)))))
		}
	}   else   {
		warning("no matrix\n")
		cracks<-matrix(c(rep(NA, 6)), nrow=6, dimnames=list(c("length", "size", "Begin_x", "Begin_y", "End_x", "End_y"),c()), byrow=FALSE)
		return(list(cracks=cracks, crackpaths=list(list(c(NA,NA))), crackclusters=list(list(c(NA,NA)))))
	}
}

