\name{crackrec}
\alias{crackrec}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{crackrec}
\description{
Finds cracks (darker areas) in an image.
}
\usage{
crackrec(x, threshold=NULL, alpha=1, beta=1, size=0)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
\item{x}{matrix representation of an image, which can be obtained by the function \command{rbmp}. }
\item{threshold}{threshold value. The default value is threshold=\command{min}\eqn{\big(140,\; \frac{4}{5}\,}{(140,}\command{mean}\eqn{(x)\big)}{(x)*4/5)}.}
\item{alpha}{parameter for weight function with values in \eqn{[0, 1]}{[0, 1]}. This parameter is optional. The default value is alpha=1.}
\item{beta}{parameter for weight function with values in \eqn{[0, 1]}{[0, 1]}. This parameter is optional. The default value is beta=1.}
\item{size}{only crackclusters greater than size=n will be considered. The default value is size=0, which means that every crackcluster is considered.}
}
\details{Here each pixel of the image with grey scale value less than the threshold value are treated as vertices of a graph. If vertice \eqn{u}{u} is a direct neighbor of vertice \eqn{v}{v}
they are connected by an undirected edge with
weight \eqn{dist\cdot\left(1 + alpha\cdot(greyValue_u+greyValue_v) + beta\cdot|greyValue_u-greyValue_v|\right)}{dist*(1 + alpha*(greyValue_u+greyValue_v) + beta*abs(greyValue_u-greyValue_v))}.
Where \eqn{dist}{dist} is equal to 1 if \eqn{u}{u} and \eqn{v}{v} coincide in one component and \eqn{\sqrt{2}}{sqrt(2)} else, \eqn{alpha}{alpha} and \eqn{beta} as described above and \eqn{\mathrm{greyValue}_u}{greyValue_u} means the grey scale value of \eqn{u}{u}.
Respectively for vertice \eqn{v}{v}.}
\value{
  a list containing:

  \item{cracks}{matrix containing crack length, crack size, start and endpoint of cracks}
  \item{crackpaths}{list of crack paths}
  \item{crackclusters}{list of connected components (maximal connected subgraphs)}
}
\author{ Arne Mueller, Alexander Stepper \email{stepper@mathematik.uni-kassel.de}}
\examples{
\dontrun{x<-rbmp("image.bmp")
crackrec(x, threshold=123, alpha=0, beta=0)}
}
\seealso{
\code{\link{rbmp}}, \code{\link{threshold.msi}}, \code{\link{shadow.remove}}, \code{\link{medianfilter}}, \code{\link{crackplot}}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{internal}
