\name{rbmp}
\alias{rbmp}
\title{rbmp}
\description{
Reads an uncompressed file in 24 bit BMP format and creates a matrix from it.
}
\usage{
rbmp(file, width = 0, height = 0, offset.x = 0, offset.y = 0)
}
\arguments{
  \item{file}{the name of the file which the data are to be read from}
  \item{width}{nonnegative integer, which should not exceed the actual image width.}
  \item{height}{nonnegative integer, which should not exceed the actual image height.}
  \item{offset.x}{nonnegative integer, horizontal offset.}
  \item{offset.y}{nonnegative integer, vertical offset.}
}

\author{Alexander Stepper \email{stepper@mathematik.uni-kassel.de}}
\examples{
rbmp("image.bmp")

# clipping, with a vertical offset of the clipping rectancle.
rbmp("image.bmp", width=696, height=512, offset.y=41) 
}
\seealso{
\code{\link{medianfilter}}, \code{\link{crackrec}}, \code{\link{crackplot}}, \code{\link{threshold.msi}}, \code{\link{shadow.remove}}.
}
\keyword{internal}
